#include <string>
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

typedef long long hash_t;
const hash_t X[2] = {997, 787};
const hash_t MOD[2] = {1230421043, 1765432198};
vector<hash_t> hashes[2];
vector<hash_t> XPOW[2];

hash_t hash(int n, int left, int right) // [left; right)
{
    hash_t res = (hashes[n][right] - hashes[n][left] * XPOW[n][right - left]) % MOD[n];
    if (res < 0)
        res += MOD[n];
    return res;
}

bool robotic(int k, int left, int right) // [left; right)
{
    if (right - left <= k)
        return false;
    return hash(0, left, right - k) == hash(0, left + k, right)
        && hash(1, left, right - k) == hash(1, left + k, right);
}

int main()
{
    ifstream in("robot.in");
    ofstream out("robot.out");
    int k;
    string s;
    in >> k >> s;
    int n = s.size();
    for (int q = 0; q < 2; q++)
    {
        XPOW[q].resize(n + 1);
        hashes[q].resize(n + 1);
        XPOW[q][0] = 1;
        hashes[q][0] = 0;
        for (int i = 0; i < n; i++)
        {
            XPOW[q][i + 1] = (XPOW[q][i] * X[q]) % MOD[q];
            hashes[q][i + 1] = (hashes[q][i] * X[q] + s[i]) % MOD[q];
        }
    }
    long long ans = 0;
    for (int i = 0; i < n - k; i++)
    {
        int left = 0;
        int right = n - i - k + 1;
        while (left + 1 < right)
        {
            int mid = (left + right) / 2;
            if (robotic(k, i, i + k + mid))
                left = mid;
            else
                right = mid;
        }
        ans += left;
    }
    out << ans << "\n";
}
