#include <string>
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

typedef long long hash_t;
const hash_t X = 997;
const hash_t MOD = 1000000007;
vector<hash_t> hashes;
vector<hash_t> XPOW;

hash_t hash(int left, int right) // [left; right)
{
    hash_t res = hashes[right] - hashes[left] * XPOW[right - left];
    res %= MOD;
    if (res < 0)
        res += MOD;
    return res;
}

bool robotic(int k, int left, int right) // [left; right)
{
    if (right - left <= k)
        return false;
    return hash(left, right - k) == hash(left + k, right);
}

int main()
{
    ifstream in("robot.in");
    ofstream out("robot.out");
    int k;
    string s;
    in >> k >> s;
    int n = s.size();
    XPOW.resize(n + 1);
    hashes.resize(n + 1);
    XPOW[0] = 1;
    hashes[0] = 0;
    for (int i = 0; i < n; i++)
    {
        XPOW[i + 1] = XPOW[i] * X;
        XPOW[i + 1] %= MOD;
        hashes[i + 1] = hashes[i] * X + s[i];
        hashes[i + 1] %= MOD;
    }
    long long ans = 0;
    for (int i = 0; i < n - k; i++)
    {
        int left = 0;
        int right = n - i - k + 1;
        while (left + 1 < right)
        {
            int mid = (left + right) / 2;
            if (robotic(k, i, i + k + mid))
                left = mid;
            else
                right = mid;
        }
        ans += left;
    }
    out << ans << "\n";
}
