import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class robot_sm_hash {
    final long P = 239;
    final long MOD = (long) 1e9 + 7;
    long[] x;
    long[] pow;
    String ss;
    long getHash(int from, int to) {
        long res = ((x[to] - (x[from] * pow[to - from]) % MOD + 2 * MOD) + MOD) % MOD;
//        System.err.println("getHash(" + from + ", " + to + ") = " + res + " " + ss.substring(from, to));
        return res;
    }

    void solve() throws IOException {
        int k = nextInt();
        ss = br.readLine();
        char[] s = ss.toCharArray();
        x = new long[s.length + 1];
        x[0] = 0;
        pow = new long[s.length + 1];
        pow[0] = 1;
        for (int i = 1; i < pow.length; i++) {
            pow[i] = (pow[i - 1] * P) % MOD;
        }
        for (int i = 0; i < s.length; i++) {
            x[i + 1] = (x[i] * P + s[i]) % MOD;
        }
        long answer = 0;
        for (int i = 0; i <= s.length - k; i++) {
            int L = i + k;
            int R = s.length + 1;
            while (L < R - 1) {
                int M = (L + R) / 2;
                if (getHash(i, M - k) == getHash(i + k, M)) {
                    L = M;
                } else {
                    R = M;
                }
            }
            answer += L - i - k;
        }
        out.println(answer);
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    void run() throws IOException {
        br = new BufferedReader(new FileReader("robot.in"));
        out = new PrintWriter("robot.out");
        solve();
        out.close();
    }

    String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        new robot_sm_hash().run();
    }
}

