#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
using namespace std;

int fst[100100];                                                                                                                                  
int nxt[200100];
int end[200100];
int bad[200100];
int perm[100100];
int answer[100100];
int edges = 0;

void addEdge(int u, int v)
{
	nxt[edges] = fst[u];
	end[edges] = v;
	fst[u] = edges++;
}

bool solve(int n, int k)
{
	for (int i = 0; i < n; i++)
		bad[i] = 0;
	for (int i = 0; k > 0 && i < n; i++)
	{
		int u = perm[i];
		if (bad[u]) continue;
		answer[k--] = u;
		for (int j = fst[u]; j != -1; j = nxt[j])
			bad[end[j]] = true;
	}	
	return k == 0;	
}

int main()
{
	freopen("tournament.in", "r", stdin);
	freopen("tournament.out", "w", stdout);
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
	{
		fst[i] = -1;
		perm[i] = i;
	}	

	for (int i = 0, a, b; i < n; i++)
	{
		scanf("%d%d", &a, &b);
		--a, --b;
		addEdge(a, b);
		addEdge(b, a);
	}	

	srand(324732);
	int k;
	scanf("%d", &k);
	for (int it = 0; it < 200; it++)
	{
		if (solve(n, k))
		{
			for (int j = 0; j < k; j++)
			{
				if (j > 0) printf(" ");
				printf("%d", answer[j] + 1);
			}
			return 0;
		}
		switch(it & 1)
		{
		case 0:
			random_shuffle(perm + 0, perm + n);
		case 1:
			reverse(perm + 0, perm + n);
		};	
	}
	puts("0");
	return 0;
}