import java.io.*;
import java.util.*;

public class tournament_pk_bruteforce {

	void solve() throws IOException {
		int n = nextInt() / 2;
		int[][] e = new int[n * 2][2];
		for (int t = 0; t < 2; t++) {
			for (int i = 0; i < n; i++) {
				int a = nextInt() - 1;
				int b = nextInt() - 1;
				e[a][t] = b;
				e[b][t] = a;
			}
		}
		int t = nextInt();

		ArrayDeque<Integer> cur = new ArrayDeque<Integer>();
		boolean[] was = new boolean[n * 2];

		ArrayDeque<Integer> ans = go(2 * n, 0, cur, was, t, e);
		
		if (ans != null) {
			for (int x : cur) {
				out.print(x + 1);
				if (x != cur.getLast())
					out.print(' ');
				else
					out.println();
			}
		} else {
			out.println(0);
		}
	}

	private ArrayDeque<Integer> go(int n, int k, ArrayDeque<Integer> cur,
			boolean[] was, int t, int[][] e) {
		if (cur.size() == t) {
			return cur;
		}
		if (k >= n)
			return null;
		for (int i = k; i < n; i++) {
			if (was[e[i][0]] || was[e[i][1]]) {
				continue;
			}
			was[i] = true;
			cur.addLast(i);
			ArrayDeque<Integer> tmp = go(n, i + 1, cur, was, t, e);
			if (tmp != null)
				return tmp;
			cur.removeLast();
			was[i] = false;
		}
		return null;
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			br = new BufferedReader(new FileReader(new File("tournament.in")));
			out = new PrintWriter("tournament.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new tournament_pk_bruteforce().run();
	}

	String nextToken() throws IOException {
		while ((st == null) || !st.hasMoreTokens())
			st = new StringTokenizer(br.readLine());
		return st.nextToken();
	}

	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(nextToken());
	}

	long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(nextToken());
	}
}
