#include <iostream>
#include <cassert>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define TASK "expedition"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

typedef long long LL;
typedef long double ldb;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <bool> vb;
typedef vector <vb> vvb;

const int INF = (1 << 30) - 1;
const ldb EPS = 1e-9;
const ldb PI = fabs(atan2(0.0, 0.0));

int n;
int c[300100];
vi all;
void load()
{
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
	{
		scanf("%d", &c[i]);
		all.pb(c[i]);
	}
	sort(all.begin(), all.end());
	all.erase(unique(all.begin(), all.end()), all.end());	
}

int find(int key, const vi &a)
{
	vi::const_iterator it = lower_bound(a.begin(), a.end(), key);
	assert(it != a.end() && *it == key);
	return (int)(it - a.begin());
}

int lst[300100];
int nxt[300100];
int cnt[300100];
int good[300100];

void solve()
{
	for (int i = 0; i < (int)all.size(); i++)
		lst[i] = 0;

	for (int i = n - 1; i >= 0; i--)
	{
		int cur = find(c[i], all);
		c[i] = cur;
		cnt[cur]++;
		nxt[i] = lst[cur];
		lst[cur] = i;
	}

	int nn = 0;
	for (int i = 0; i < n; i++)
	{
		if (cnt[c[i]] > 1)
			good[nn++] = i;
	}

	if (nn == 0 || good[nn - 1] != n - 1)
	{
		puts("0");
		return;
	}
	
	vi answer;
	int i = 0;
	while (true)
	{
		int pos = good[i];
		answer.pb(pos);
		if (nxt[pos] == n - 1) break;
		int best = good[i + 1];
		int ni = i + 1;
		for (int j = i + 1; good[j] <= nxt[pos]; j++)
		{
			if (nxt[good[j]] > nxt[best])
			{
				best = good[j];
				ni = j;
			}	
		}
		if (nxt[best] == 0)
		{
			puts("0");
			return;
		}
		i = ni;
	}

	printf("%d\n", answer.size());
	for (int i = 0; i < (int)answer.size(); i++)
	{
		if (i > 0) printf(" ");
		printf("%d", answer[i] + 1);
	}
}

int main()
{
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
	load();
	solve();
	return 0;
}
