#include <iostream>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define TASK "expedition"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

typedef long long LL;
typedef long double ldb;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <bool> vb;
typedef vector <vb> vvb;

const int INF = (1 << 30) - 1;
const ldb EPS = 1e-9;
const ldb PI = fabs(atan2(0.0, 0.0));

inline int rndInt()
{
	int r = (rand() << 16) | rand();
	if (r < 0) r = -r;
	if (r < 0) r = 0;
	return r;
}

int n;
int c[300100];
vi all;
void load()
{
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
	{
		scanf("%d", &c[i]);
		all.pb(c[i]);
	}
	sort(all.begin(), all.end());
	all.erase(unique(all.begin(), all.end()), all.end());	
}

int find(int key, const vi &a)
{
	vi::const_iterator it = lower_bound(a.begin(), a.end(), key);
	assert(it != a.end() && *it == key);
	return (int)(it - a.begin());
}

int lst[300100];
int nxt[300100];

int dp[300100];
int pr[300100];

const int MAXIT = 500;
int f(int i)
{
	if (i >= n - 1)
		return 0;
	if (nxt[i] == 0)
		return INF;
	
	int &res = dp[i];
	int &best = pr[i];
	if (res != 0)
		return res;
	res = INF;
	best = 0;
	int left = i + 1;
	int right = nxt[i];
	for (int it = 0; it < MAXIT; it++)
	{
		int x = left + (rndInt() % (right - left + 1));
		int cur = f(x) + 1;
		if (cur < res)
		{
			res = cur;
			best = x;
		}
	}
	return res;	
}

void out(int i)
{
	if (i >= n - 1)
		return;
	printf("%d ", i + 1);
	assert(pr[i] != 0);
	out(pr[i]);	
}

void solve()
{
	for (int i = 0; i < (int)all.size(); i++)
		lst[i] = 0;

	for (int i = n - 1; i >= 0; i--)
	{
		int cur = find(c[i], all);
		nxt[i] = lst[cur];
		lst[cur] = i;
	}

	memset(dp, 0, sizeof(dp));
	int res = f(0);
	if (res == INF)
		puts("0");
	else
	{	
		printf("%d\n", res);
		out(0);
	}	
}

int main()
{
	srand(237432);
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
	load();
	solve();
	return 0;
}
