#include <iostream>
#include <cassert>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define TASK "expedition"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

typedef long long LL;
typedef long double ldb;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <bool> vb;
typedef vector <vb> vvb;

const int INF = (1 << 30) - 1;
const ldb EPS = 1e-9;
const ldb PI = fabs(atan2(0.0, 0.0));

int n;
int c[300100];
vi all;
void load()
{
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
	{
		scanf("%d", &c[i]);
		all.pb(c[i]);
	}
	sort(all.begin(), all.end());
	all.erase(unique(all.begin(), all.end()), all.end());	
}

int find(int key, const vi &a)
{
	vi::const_iterator it = lower_bound(a.begin(), a.end(), key);
	assert(it != a.end() && *it == key);
	return (int)(it - a.begin());
}

int lst[300100];
int nxt[300100];


inline int mmax(int i, int j)
{
	if (i == 0) return j;
	if (j == 0) return i;
	return nxt[i] > nxt[j] ? i : j;
}

int tree[2000100];

void build(int v, int l, int r)
{
	if (r - l == 1)
	{
		tree[v] = l;
		return;
	}
	int md = (l + r) / 2;
	build(2 * v + 1, l, md);
	build(2 * v + 2, md, r);
	tree[v] = mmax(tree[2 * v + 1], tree[2 * v + 2]);
}

int get(int v, int l, int r, int ql, int qr)
{
	if (l >= qr || r <= ql)
		return 0;
	if (ql <= l && r <= qr)
		return tree[v];
	int md = (l + r) / 2;
	return mmax(get(2 * v + 1, l, md, ql, qr),
				get(2 * v + 2, md, r, ql, qr));	
}

void solve()
{
	for (int i = 0; i < (int)all.size(); i++)
		lst[i] = 0;

	for (int i = n - 1; i >= 0; i--)
	{
		int cur = find(c[i], all);
		nxt[i] = lst[cur];
		lst[cur] = i;
	}
	
	build(0, 0, n);

	vi answer;
	int pos = 0;
	while (pos < n)
	{
		if (nxt[pos] == 0)
		{
			puts("0");
			return;
		}
		answer.pb(pos);
		if (nxt[pos] >= n - 1) break;
		int j = get(0, 0, n, pos + 1, nxt[pos] + 1);
		pos = j;
	}

	printf("%d\n", answer.size());
	for (int i = 0; i < (int)answer.size(); i++)
	{
		if (i > 0) printf(" ");
		printf("%d", answer[i] + 1);
	}
}

int main()
{
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
	load();
	solve();
	return 0;
}
