#include <cstdio>
#include <ctime>
#include <algorithm>
#include <vector>
#include <queue>
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
using namespace std;

const int inf = (int) 1e9 + 1;
const int N = 1 << 20;
int n, data_x[N], data_y[N], x[N][2], y[N][2], ansx[N], ansy[N], cur[N], pos[2 * N];
bool used[N];
priority_queue<int> available[N], available_x;
vector<int> allx, ally;
vector< pair<int, int> > x_events[N], y_events[N];

void compress(int (&x)[N][2], int n, vector<int> &allx) {
	for (int i = 0; i < n; ++i)
		for (int t = 0; t < 2; ++t)
			for (int delta = 0; delta <= 1; ++delta)
				allx.pb(x[i][t] + delta);
	allx.pb(inf);
	sort(allx.begin(), allx.end());
	allx.resize(unique(allx.begin(), allx.end()) - allx.begin());
	for (int i = 0; i < n; ++i)
		for (int t = 0; t < 2; ++t)
			x[i][t] = lower_bound(allx.begin(), allx.end(), x[i][t]) - allx.begin();
}

void relax(int &pos, int tmp) {
	if (cur[pos] > cur[tmp])
		pos = tmp;
}

void update(int i, int value) {
	if (cur[i] == value)
		return;
	cur[i] = value;
	pos[i + N - 1] = i;
	i += N - 1;
	while (i > 0) {
		i = (i - 1) / 2;
		pos[i] = (cur[pos[i * 2 + 1]] < cur[pos[i * 2 + 2]]) ? pos[i * 2 + 1] : pos[i * 2 + 2];
	}
}

int get(int l, int r) {
	int ans_pos = l;
	l += N - 1, r += N - 1;
	while (l < r) {
		if (!(l & 1)) {
			relax(ans_pos, pos[l]);
			l++;
		}
		if (r & 1) {
			relax(ans_pos, pos[r]);
			r--;
		}
		l = (l - 1) / 2, r = (r - 1) / 2;
	}
	if (l == r)
		relax(ans_pos, pos[l]);
	return ans_pos;
}

void fix_available(priority_queue<int> &q) {
	while ((q.top() != -1) && !used[q.top()])
		q.pop();
}

void add_horizontal(int y, int num, int x1, int x2) {
	x_events[y].pb(mp(x1, num));
	x_events[y].pb(mp(x2 + 1, num));
}

void add_vertical(int x, int num, int y1, int y2) {
	y_events[y1].pb(mp(x, num));
	y_events[y2 + 1].pb(mp(x, num));
}

void try_to_find_answer(int num, int l, int r) {
	l = max(l, x[num][0]);
	r = min(r - 1, x[num][1]);	
	if ((ansx[num] == 0) && (l <= r)) {
		int pos = get(l, r);
		if (cur[pos] < num) {
			ansx[num] = allx[pos];
			ansy[num] = ally[y[num][0]];
		}
	}
}

void clear(priority_queue<int>& q) {
	while (!q.empty())
		q.pop();
}

void solve() {
	for (int i = 0; i < sz(ally); ++i) {
		y_events[i].clear();
		x_events[i].clear();
	}
	for (int i = 0; i < sz(allx); ++i) {
		clear(available[i]);
		available[i].push(-1);
		update(i, -1);
	}
	clear(available_x);
	available_x.push(-1);
	for (int i = 0; i < n; ++i) {
		used[i] = false;
		if (x[i][0] == x[i][1])
			add_vertical(x[i][0], i, y[i][0], y[i][1]);
		else
			add_horizontal(y[i][0], i, x[i][0], x[i][1]);
	}
	for (int i = 0; i < sz(ally); ++i) {
		for (int j = 0; j < sz(y_events[i]); ++j) {
			if (used[y_events[i][j].sc] ^= 1)
				available[y_events[i][j].fs].push(y_events[i][j].sc);
			fix_available(available[y_events[i][j].fs]);
			update(y_events[i][j].fs, available[y_events[i][j].fs].top());
		}
		sort(x_events[i].begin(), x_events[i].end());
		for (int j = 0; j < sz(x_events[i]); ++j) {
			if (used[x_events[i][j].sc] ^= 1)
				available_x.push(x_events[i][j].sc);
			fix_available(available_x);
			if (available_x.top() != -1)
				try_to_find_answer(available_x.top(), x_events[i][j].fs, x_events[i][j + 1].fs);
		}
		for (int j = 0; j < sz(x_events[i]); ++j)
			if (ansx[x_events[i][j].sc] == 0) {
				printf("0\n");
				exit(0);
			}
	}
}

int main() {
	double start = clock();
	freopen("flashmob.in", "r", stdin);
	freopen("flashmob.out", "w", stdout);
	scanf("%d", &n);
	for (int i = n - 1; i >= 0; --i) {
		for (int t = 0; t < 2; ++t)
			scanf("%d%d", &x[i][t], &y[i][t]);
		sort(x[i], x[i] + 2);
		sort(y[i], y[i] + 2);
	}
	compress(x, n, allx);
	compress(y, n, ally);
	for (int it = 0; it < 2; ++it) {
		solve();
		swap(x, y);
		swap(allx, ally);
		swap(ansx, ansy);
	}
	printf("%d\n", n);
	for (int i = 0; i < n; ++i)
		printf("%d %d\n", ansx[i], ansy[i]);
	fprintf(stderr, "%.2lf\n", (clock() - start) / CLOCKS_PER_SEC);
	return 0;
}