#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <algorithm>
#include <set>
#include <vector>
using namespace std;

#define mp make_pair
#define pb push_back
#define fs first
#define sc second
#define sz(a) ((int) (a).size())

const int inf = (int) 1e9 + 1;
const int N = (int) (123456 + 1) * 4;
vector<int> open[N], close[N], data[N], allx, ally;
vector< pair<int, int> > ans, res;
pair<int, int> rmq[4 * N];
set<int> current[N];
int assigned[4 * N], state[N], n, x[N][2], y[N][2];

void rmq_assign(int t, int l, int r, int x, int y, int value) {
	if ((y < l) || (r < x))
		return;
	if ((x <= l) && (r <= y)) {
		assigned[t] = value;
		rmq[t] = (l == r) ? mp(state[l], l) : max(rmq[t * 2 + 1], rmq[t * 2 + 2]);
		rmq[t].fs = min(rmq[t].fs, assigned[t]);
		return;
	}
	int m = (l + r) / 2;
	rmq_assign(t * 2 + 1, l, m, x, y, value);
	rmq_assign(t * 2 + 2, m + 1, r, x, y, value);
	rmq[t] = max(rmq[t * 2 + 1], rmq[t * 2 + 2]);
	rmq[t].fs = min(rmq[t].fs, assigned[t]);
}

pair<int, int> rmq_get(int t, int l, int r, int x, int y) {
	if ((y < l) || (r < x))
		return mp(-inf, -1);
	if ((x <= l) && (r <= y))
		return rmq[t];
	int m = (l + r) / 2;
	pair<int, int> res = max(rmq_get(t * 2 + 1, l, m, x, y), rmq_get(t * 2 + 2, m + 1, r, x, y));
	res.fs = min(res.fs, assigned[t]);
	return res;
} 

void assign(int l, int r, int value) {
	rmq_assign(0, 0, sz(allx) - 1, l, r, value);
}

pair<int, int> get(int l, int r) {
	return rmq_get(0, 0, sz(allx) - 1, l, r);
}

void update(int i, int value) {
	state[i] = value;
	assign(i, i, value);
}

void no_solution() {
	printf("0\n");
	exit(0);
}

void solve() {
	for (int i = 0; i < sz(ally); ++i) {
		open[i].clear();
		close[i].clear();
		data[i].clear();
	}
	for (int i = 0; i < n; ++i)
		if (x[i][0] == x[i][1]) {
			open[y[i][0]].pb(i);
			close[y[i][1]].pb(i);
		} else
			data[y[i][0]].pb(i);
	for (int i = 0; i < 4 * N; ++i)
		assigned[i] = inf;
	for (int i = 0; i < sz(allx); ++i) {
		update(i, inf);
		current[i].clear();
		current[i].insert(inf);
	}
	ans.clear();
	for (int i = 0; i < sz(ally); ++i) {
		for (int j = 0; j < sz(open[i]); ++j) {
			current[x[open[i][j]][0]].insert(open[i][j]);
			update(x[open[i][j]][0], *current[x[open[i][j]][0]].begin());
		}
		sort(data[i].begin(), data[i].end());
		for (int j = 0; j < sz(data[i]); ++j) {
			int l = x[data[i][j]][0], r = x[data[i][j]][1];
			pair<int, int> value = get(l, r);
			if (value.fs < data[i][j])
				no_solution();
			ans.pb(mp(value.sc, i));
			assign(l, r, data[i][j]);
		}
		for (int j = 0; j < sz(data[i]); ++j) {
			int l = x[data[i][j]][0], r = x[data[i][j]][1];
			assign(l, r, inf);
		}
		for (int j = 0; j < sz(close[i]); ++j) {
			current[x[close[i][j]][0]].erase(close[i][j]);
			update(x[close[i][j]][0], *current[x[close[i][j]][0]].begin());
		}
	}	
}

void compress(int n, int (&x)[N][2], vector<int>& allx) {
	for (int i = 0; i < n; ++i)
		for (int t = 0; t < 2; ++t)
			for (int delta = -1; delta <= 1; ++delta)
				allx.pb(x[i][t] + delta);
	sort(allx.begin(), allx.end());
	allx.resize(unique(allx.begin(), allx.end()) - allx.begin());
	for (int i = 0; i < n; ++i)
		for (int t = 0; t < 2; ++t)
			x[i][t] = lower_bound(allx.begin(), allx.end(), x[i][t]) - allx.begin();
}

int main() {
	freopen("flashmob.in", "r", stdin);
	freopen("flashmob.out", "w", stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		for (int t = 0; t < 2; ++t)
			scanf("%d%d", &x[i][t], &y[i][t]);
		sort(x[i], x[i] + 2);
		sort(y[i], y[i] + 2);
	}
	compress(n, x, allx);
	compress(n, y, ally);
	for (int t = 0; t < 2; ++t) {
		solve();
		for (int i = 0; i < sz(ans); ++i)
			res.pb((t == 0) ? mp(ans[i].fs, ans[i].sc) : mp(ans[i].sc, ans[i].fs));
		for (int i = 0; i < n; ++i)
			swap(x[i], y[i]);
		swap(allx, ally);
	}
	printf("%d\n", sz(res));
	for (int i = 0; i < sz(res); ++i)
		printf("%d %d\n", allx[res[i].fs], ally[res[i].sc]);
	return 0;
}
