import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class flashmob_sm_greed_first {

    private Segment[] ss;

    static class Point {
        int x, y;

        Point(int x, int y) {
            this.x = x;
            this.y = y;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            Point point = (Point) o;

            if (x != point.x) return false;
            if (y != point.y) return false;

            return true;
        }

        @Override
        public int hashCode() {
            int result = x;
            result = 31 * result + y;
            return result;
        }
    }

    boolean contains(Point a, Point s1, Point s2) {
        if (s1.x == a.x && s2.x == a.x) {
            return Math.min(s1.y, s2.y) <= a.y && a.y <= Math.max(s1.y, s2.y);
        } else if (s1.y == a.y && s2.y == a.y) {
            return Math.min(s1.x, s2.x) <= a.x && a.x <= Math.max(s1.x, s2.x);
        }
        return false;
    }

    static class Segment {
        Point a, b;

        Segment(Point a, Point b) {
            this.a = a;
            this.b = b;
        }
    }

    int n;

    void solve() throws IOException {
        readInput();
        out.println(n);
        for (int i = 0; i < n; i++) {
            if (ss[i].a.x == ss[i].b.x) {
                out.println(ss[i].a.x + " " + (ss[i].a.y + 1));
            } else {
                out.println(ss[i].a.x + 1 + " " + (ss[i].a.y));
            }
        }
    }

    private void readInput() throws IOException {
        n = nextInt();
        ss = new Segment[n];
        for (int i = 0; i < n; i++) {
            int x1 = nextInt();
            int y1 = nextInt();
            int x2 = nextInt();
            int y2 = nextInt();
            ss[i] = new Segment(new Point(Math.min(x1, x2), Math.min(y1, y2)), new Point(Math.max(x1, x2), Math.max(y1, y2)));
        }
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    void run() throws IOException {
        br = new BufferedReader(new FileReader("flashmob.in"));
        out = new PrintWriter("flashmob.out");
        solve();
        out.close();
    }

    String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        new flashmob_sm_greed_first().run();
    }
}
