import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Random;
import java.util.Set;
import java.util.StringTokenizer;

public class flashmob_sm_random_not_used {

    private Segment[] ss;

    static class Point {
        int x, y;

        Point(int x, int y) {
            this.x = x;
            this.y = y;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            Point point = (Point) o;

            if (x != point.x) return false;
            if (y != point.y) return false;

            return true;
        }

        @Override
        public int hashCode() {
            int result = x;
            result = 31 * result + y;
            return result;
        }
    }

    static class Segment {
        Point a, b;

        Segment(Point a, Point b) {
            this.a = a;
            this.b = b;
        }
    }

    int n;

    Random rand = new Random(1);

    void solve() throws IOException {
        readInput();
        out.println(n);
        Set<Integer> usedx = new HashSet<>();
        Set<Integer> usedy = new HashSet<>();
        for (int i = 0; i < n; i++) {
            if (ss[i].a.x == ss[i].b.x) {
                usedx.add(ss[i].a.x);
            } else {
                usedy.add(ss[i].a.y);
            }
        }
        for (int i = 0; i < n; i++) {
            if (ss[i].a.x == ss[i].b.x) {
                int y = numberInIntervalExclude(ss[i].a.y, ss[i].b.y, usedy);
                out.println(ss[i].a.x + " " + y);
            } else {
                int x = numberInIntervalExclude(ss[i].a.x, ss[i].b.x, usedx);
                out.println(x + " " + ss[i].a.y);
            }
            out.flush();
        }
    }

    private int numberInIntervalExclude(int a1, int a2, Set<Integer> used) {
        int y;
        do {
            y = randomBetween(a1, a2);
        } while (used.contains(y));
        return y;
    }

    private int randomBetween(int a1, int a2) {
        return (a1 + rand.nextInt(a2 - a1 - 2) + 1);
    }

    private void readInput() throws IOException {
        n = nextInt();
        ss = new Segment[n];
        for (int i = 0; i < n; i++) {
            int x1 = nextInt();
            int y1 = nextInt();
            int x2 = nextInt();
            int y2 = nextInt();
            ss[i] = new Segment(new Point(Math.min(x1, x2), Math.min(y1, y2)), new Point(Math.max(x1, x2), Math.max(y1, y2)));
        }
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    void run() throws IOException {
        br = new BufferedReader(new FileReader("flashmob.in"));
        out = new PrintWriter("flashmob.out");
        solve();
        out.close();
    }

    String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        new flashmob_sm_random_not_used().run();
    }
}
