#include <iostream>
#include <cassert>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

typedef long long LL;
typedef long double ldb;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <bool> vb;
typedef vector <vb> vvb;

const int INF = (1 << 30) - 1;
const ldb EPS = 1e-9;
const ldb PI = fabs(atan2(0.0, -1.0));

int n, t, k;
int m;
vector <pii> segments;

inline int getShips(int left, int right)
{
	if (left > right) return 0;
	return (right - left + 2) / (k + 1);
}

int getShips()
{
	int result = 0;
	for (int i = 0; i < (int)segments.size(); i++)
		result += getShips(segments[i].fi, segments[i].se);
	return result;
}

int getPoints(int ships)
{
	int result = 0;
	for (int i = 0; i < (int)segments.size(); i++)
	{
		int left = segments[i].fi;
		int right = segments[i].se;
		int curShips = ships - getShips(left, right);
		for (int j = left; j <= right; j++)
		{
			int tmp = getShips(left, j - 1) + getShips(j + 1, right);
			if (curShips + tmp < t) result++;
		}
	}
	return result;
}

void solve()
{
	scanf("%d%d%d", &n, &t, &k);
	segments.pb(mp(0, n - 1));
	
	int ships = getShips();
	int points = getPoints(ships);

	printf("%d\n", ships == t ? points : 0);
	fflush(stdout);

	for (int shot; ;)
	{
		scanf("%d", &shot);
		--shot;
		int left = -1;
		int right = -1;
		for (int i = 0; i < (int)segments.size(); i++)
		{
			if (segments[i].fi <= shot && shot <= segments[i].se)
			{
				left = segments[i].fi;
				right = segments[i].se;
				segments.erase(segments.begin() + i);
				break;
			}
		}
		assert(left != -1);
		if (left < shot) segments.pb(mp(left, shot - 1));
		if (shot < right) segments.pb(mp(shot + 1, right));
		ships = getShips();
		points = getPoints(ships);
		if (ships < t)
			break;
		printf("0 %d\n", ships == t ? points : 0);
		fflush(stdout);	
	}
	printf("1\n");
	fflush(stdout);
}

int main()
{
	solve();
	return 0;
}
