{$Q+,R+,O-}
const
	MAXN = 100000;
	TREESIZE = 500000;
	INF = 1000000000;
var
	left, right: longint;
	tmin, tmax: array[1..TREESIZE] of longint;
	n, k, t: longint;
	shot, sumShips, sumPoints: longint;

function min(a, b: longint): longint;
begin
	if a < b then begin
		min := a;
	end else begin
		min := b;
	end;
end;

function max(a, b: longint): longint;
begin
	if a > b then begin
		max := a;
	end else begin
		max := b;
	end;
end;
	
procedure build(v, l, r: longint);
begin
	if r - l = 1 then begin
		tmin[v] := INF;
		tmax[v] := -INF;
		exit;
	end;
	build(2 * v, l, (l + r) div 2);
	build(2 * v + 1, (l + r) div 2, r);
	tmin[v] := INF;
	tmax[v] := -INF;
end;

procedure updMin(v, l, r, x, val: longint);
begin
	if (x < l) or (x >= r) then begin
		exit;
	end;
	if r - l = 1 then begin
		tmin[v] := val;
		exit;
	end;
	updMin(2 * v, l, (l + r) div 2, x, val);
	updMin(2 * v + 1, (l + r) div 2, r, x, val);
	tmin[v] := min(tmin[2 * v], tmin[2 * v + 1]);
end;

procedure updMax(v, l, r, x, val: longint);
begin
	if (x < l) or (x >= r) then begin
		exit;
	end;
	if r - l = 1 then begin
		tmax[v] := val;
		exit;
	end;
	updMax(2 * v, l, (l + r) div 2, x, val);
	updMax(2 * v + 1, (l + r) div 2, r, x, val);
	tmax[v] := max(tmax[2 * v], tmax[2 * v + 1]);
end;

function getMin(v, l, r, ql, qr: longint): longint;
begin
	if (ql >= r) or (l >= qr) then begin
		getMin := INF;
		exit;
	end;
	if (ql <= l) and (r <= qr) then begin
		getMin := tmin[v];
		exit;
	end;
	getMin := min(getMin(2 * v, l, (l + r) div 2, ql, qr),
				  getMin(2 * v + 1, (l + r) div 2, r, ql, qr));
end;

function getMax(v, l, r, ql, qr: longint): longint;
begin
	if (ql >= r) or (l >= qr) then begin
		getMax := -INF;
		exit;
	end;
	if (ql <= l) and (r <= qr) then begin
		getMax := tmax[v];
		exit;
	end;
	getMax := max(getMax(2 * v, l, (l + r) div 2, ql, qr),
				  getMax(2 * v + 1, (l + r) div 2, r, ql, qr));
end;


function getShips(l, r: longint): longint;
begin
	getShips := (r - l + 2) div (k + 1);
end;

function getPoints(l, r: longint): longint;
var
	last, ships: longint;
begin
	ships := getShips(l, r);
	last := r - l + 1 - k * ships - ships + 1;
	getPoints := max(0, ships * (k - last));
end;

procedure add(l, r: longint);
begin
	if l > r then begin
		exit;
	end;
	updMax(1, 1, n + 1, l, l);

	updMin(1, 1, n + 1, r, r);
	
	sumShips := sumShips + getShips(l, r);
	sumPoints := sumPoints + getPoints(l, r);
end;
	
begin
	readln(n, t, k);
	sumShips := 0;
	sumPoints := 0;
	build(1, 1, n + 1);
	add(1, n);
	if sumShips > t then begin
		writeln(0);
	end else begin
		writeln(sumPoints);
	end;
	flush(output);
	while true do begin
		readln(shot);
		left := getMax(1, 1, n + 1, 1, shot + 1);
		right := getMin(1, 1, n + 1, shot, n + 1);

		assert((left <= shot) and (shot <= right)); 
		assert((left <> -INF) and (right <> INF));

		sumShips := sumShips - getShips(left, right);
		sumPoints := sumPoints - getPoints(left, right);

		updMin(1, 1, n + 1, shot, INF);
		updMax(1, 1, n + 1, shot, -INF);

		add(left, shot - 1);
		add(shot + 1, right);

		if sumShips < t then begin
			writeln(1);
			flush(output);
			break;
		end;
		if sumShips > t then begin
			writeln(0, ' ', 0);
		end else begin
			writeln(0, ' ', sumPoints);
		end;
		flush(output);
	end;
end.
