import java.io.*;
import java.util.*;

public class sea_pk_60 {

	void solve() throws IOException {
		int n = nextInt();
		int t = nextInt();
		int k = nextInt();
		if (n > 3000)
		  throw new AssertionError();

		TreeSet<Integer> state = new TreeSet<Integer>();
		state.add(0);
		state.add(n + 1);
		
		int currentCount = 0;
		int currentAnswer = 0;
		for (int x : state) {
			if (x == state.last())
				break;
			currentCount += getCount((state.higher(x) - x - 1), k);
			currentAnswer += getAnswer((state.higher(x) - x - 1), k);
		}
		if (currentCount == t) {
			out.println(currentAnswer);
		} else {
			out.println(0);
		}
		out.flush();

		while (true) {
			int x = nextInt();
			int left = state.lower(x);
			int right = state.higher(x);

			int l = right - left - 1;
			int l1 = x - left - 1;
			int l2 = right - x - 1;
			state.add(x);
			currentCount -= getCount(l, k);
			currentCount += getCount(l1, k) + getCount(l2, k);

			if (currentCount < t) {
				out.println(1);
				out.flush();
				return;
			}
			currentAnswer -= getAnswer(l, k);
			currentAnswer += getAnswer(l1, k) + getAnswer(l2, k);
			out.print(0 + " ");
			if (currentCount > t) {
				out.println(0);
				out.flush();
				continue;
			}
			if (currentCount == t) {
				out.println(currentAnswer);
			} else {
				out.println(0);
			}
			out.flush();

		}
	}

	private int getAnswer(int l, int k) {
		int cnt = getCount(l, k);
		return Math.max(cnt * (k - (l - k * cnt - cnt + 1)), 0);
	}

	private int getCount(int l, int k) {
		return (l + 1) / (k + 1);
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new sea_pk_60().run();
	}

	String nextToken() throws IOException {
		while ((st == null) || !st.hasMoreTokens())
			st = new StringTokenizer(br.readLine());
		return st.nextToken();
	}

	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(nextToken());
	}

	long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(nextToken());
	}
}
